/*
 * Example for Mic click
 *
 * Date         Mar 2017
 * Author       Djordje Rosic
 * Copyright    GNU Public License v2
 *
 * Test configuration AVR :
 *  MCU           :        ATMEGA32
 *  Dev. Board    :        EasyAVR v7
 *  SW            :        mikroC PRO for AVR v6.1.2
 *
 * Note: Turn on switches for SPI communication, and GLCD backlight.
 ******************************************************************************/
#include <stdint.h>

// Glcd module connections
char GLCD_DataPort at PORTC;
char GLCD_DataPort_Direction at DDRC;

sbit GLCD_CS1 at PORTB0_bit;
sbit GLCD_CS2 at PORTB1_bit;
sbit GLCD_RS  at PORTA2_bit;
sbit GLCD_RW  at PORTA3_bit;
sbit GLCD_EN  at PORTD6_bit;
sbit GLCD_RST at PORTD7_bit;

sbit GLCD_CS1_Direction at DDB0_bit;
sbit GLCD_CS2_Direction at DDB1_bit;
sbit GLCD_RS_Direction  at DDA2_bit;
sbit GLCD_RW_Direction  at DDA3_bit;
sbit GLCD_EN_Direction  at DDD6_bit;
sbit GLCD_RST_Direction at DDD7_bit;
// End Glcd module connections



uint16_t xCoordinate;
uint16_t yCoordinate;
uint16_t oldx;
uint16_t oldy;


static void systemInit( void );
/*
 * System Initialization
 */
void systemInit ()
{

    xCoordinate = 1;
    oldx = 0;
    oldy = 24;

    Glcd_Init();                                   // Initialize GLCD
    Glcd_Fill(0x00);                               // Clear GLCD
    Glcd_Write_Text ("Mic click", 10,0,1);
}

void main()
{
    uint16_t measuredValue;
    systemInit ();
    while (1)
    {
        measuredValue = ADC_Read(7);

        yCoordinate=measuredValue/23+20;
        if (xCoordinate != 0)
            Glcd_Line (xCoordinate, yCoordinate, oldx, oldy, 1);
        oldx = xCoordinate;
        oldy = yCoordinate;
        Delay_ms (20);
        xCoordinate++;
        if (xCoordinate==127)
        {
            xCoordinate=0;
            Glcd_Fill(0x00);
            Glcd_Write_Text ("Mic click", 10,0,1);
        }
    }
}
/************************************************************ END OF FILE *****/